"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _terraDocTemplate = _interopRequireDefault(require("terra-doc-template"));

var _README = _interopRequireDefault(require("../../../../docs/README.md"));

var _package = require("../../../../package.json");

var _SearchField = _interopRequireDefault(require("!terra-props-table-loader!../../../../src/SearchField"));

var _SearchField2 = _interopRequireDefault(require("!raw-loader!../../../../src/SearchField"));

var _SearchFieldBasic = _interopRequireDefault(require("../example/SearchFieldBasic"));

var _SearchFieldBasic2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldBasic"));

var _SearchFieldPlaceholder = _interopRequireDefault(require("../example/SearchFieldPlaceholder"));

var _SearchFieldPlaceholder2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldPlaceholder"));

var _SearchFieldMinimumLength = _interopRequireDefault(require("../example/SearchFieldMinimumLength"));

var _SearchFieldMinimumLength2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldMinimumLength"));

var _SearchFieldDelayed = _interopRequireDefault(require("../example/SearchFieldDelayed"));

var _SearchFieldDelayed2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldDelayed"));

var _SearchFieldDefaultValue = _interopRequireDefault(require("../example/SearchFieldDefaultValue"));

var _SearchFieldDefaultValue2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldDefaultValue"));

var _SearchFieldDisabled = _interopRequireDefault(require("../example/SearchFieldDisabled"));

var _SearchFieldDisabled2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldDisabled"));

var _SearchFieldDisableAutoFormatAttrs = _interopRequireDefault(require("../example/SearchFieldDisableAutoFormatAttrs"));

var _SearchFieldDisableAutoFormatAttrs2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldDisableAutoFormatAttrs"));

var _SearchFieldBlock = _interopRequireDefault(require("../example/SearchFieldBlock"));

var _SearchFieldBlock2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldBlock"));

var _SearchFieldDisableAutoSearch = _interopRequireDefault(require("../example/SearchFieldDisableAutoSearch"));

var _SearchFieldDisableAutoSearch2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldDisableAutoSearch"));

var _SearchFieldFilterNumeric = _interopRequireDefault(require("../example/SearchFieldFilterNumeric"));

var _SearchFieldFilterNumeric2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldFilterNumeric"));

var _SearchFieldFocus = _interopRequireDefault(require("../example/SearchFieldFocus"));

var _SearchFieldFocus2 = _interopRequireDefault(require("!raw-loader!../../../../src/terra-dev-site/doc/example/SearchFieldFocus"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Example Files
var DocPage = function DocPage() {
  return _react.default.createElement(_terraDocTemplate.default, {
    packageName: _package.name,
    packageVersion: _package.version,
    readme: _README.default,
    srcPath: "https://github.com/cerner/terra-core/tree/master/packages/".concat(_package.name),
    examples: [{
      title: 'Search Field',
      example: _react.default.createElement(_SearchFieldBasic.default, null),
      source: _SearchFieldBasic2.default
    }, {
      title: 'Search Field with Placeholder Text',
      example: _react.default.createElement(_SearchFieldPlaceholder.default, null),
      source: _SearchFieldPlaceholder2.default
    }, {
      title: 'Search Field with Minimum Search Text Length of 5 Characters',
      example: _react.default.createElement(_SearchFieldMinimumLength.default, null),
      source: _SearchFieldMinimumLength2.default
    }, {
      title: 'Search Field with Delay of 2000ms',
      example: _react.default.createElement(_SearchFieldDelayed.default, null),
      source: _SearchFieldDelayed2.default
    }, {
      title: 'Search Field with a Default Value',
      example: _react.default.createElement(_SearchFieldDefaultValue.default, null),
      source: _SearchFieldDefaultValue2.default
    }, {
      title: 'Search Field that is Disabled',
      example: _react.default.createElement(_SearchFieldDisabled.default, null),
      source: _SearchFieldDisabled2.default
    }, {
      title: 'Search Field that has Autocomplete, Autocorrect, Autocapitalize, and Spellcheck disabled',
      example: _react.default.createElement(_SearchFieldDisableAutoFormatAttrs.default, null),
      source: _SearchFieldDisableAutoFormatAttrs2.default
    }, {
      title: 'Search Field that Displays as Block Style to Fill Container',
      example: _react.default.createElement(_SearchFieldBlock.default, null),
      source: _SearchFieldBlock2.default
    }, {
      title: 'Search Field with Auto-search Turned Off',
      example: _react.default.createElement(_SearchFieldDisableAutoSearch.default, null),
      source: _SearchFieldDisableAutoSearch2.default
    }, {
      title: 'Search Field with onChange Event Filtering Numbers',
      example: _react.default.createElement(_SearchFieldFilterNumeric.default, null),
      source: _SearchFieldFilterNumeric2.default
    }, {
      title: 'Search Field with Focus',
      example: _react.default.createElement(_SearchFieldFocus.default, null),
      source: _SearchFieldFocus2.default
    }],
    propsTables: [{
      componentName: 'Search Field',
      componentSrc: _SearchField2.default,
      componentProps: _SearchField.default
    }]
  });
};

var _default = DocPage;
exports.default = _default;